#include <iostream>
#include <Grace.h>
#include <unistd.h>

#include "Region.h"
#include "Evaluator.h"

using namespace std;

int main()
{
	Grace grace;

	grace.readSets("test.dat");

	cout<<"Reading regions ..."<<endl;
	vector<string> regions = grace.regionSelection();
	for (unsigned i=0; i<regions.size(); ++i)
		cout<<"Region "<<i<<" : "<<regions[i]<<endl;
	grace.writeSet(0,"tmp.dat");

	GeoRegion r = Grace::toRegion(regions);
	for (unsigned i=0; i<r.size(); ++i) {
		Component &c = r[i];
		for (unsigned n=0; n<c.size(); ++n) {
			string expr;
			if (c[n]->is2D())
				expr = c[n]->toSelectExpression("X", "Y");
			else
				expr = c[n]->toSelectExpression("X");

			cout<<c[n]->name()<<" : "<<expr<<endl;
			assert(Evaluator::isValidExpression(expr));
		}
	}
	r.free();

	return 0;
}
