#include <iostream>
#include <sstream>
#include <cmath>
#include<cassert>

#include <Dal.h>
/*AI gcc4 porting
* error: ‘strncpy’ was not declared in this scope
* => #include <cstring>
*/
#include <cstring>
using namespace std;

int main()
{
	unsigned long nRows = 100;

	DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
	Table* tab = set->addTable("some",nRows);
	Column *col;
	ColumnData *d;

	col = tab->addColumn("bool",Column::Bool,"bool data");
	d = col->data();
	bool8 *b = d->boolData();
	for (unsigned long i = 0; i < nRows; ++i)
		b[i] = (i%2 ? true : false);
	delete d;

	col = tab->addColumn("int8",Column::Int8,"int8 data","mm");
	d = col->data();
	int8 *i8 = d->int8Data();
	for (unsigned long i = 0; i < nRows; ++i)
		i8[i] = i;
	delete d;

	col = tab->addColumn("int16",Column::Int16,"int16 data","cm");
	d = col->data();
	int16 *i16 = d->int16Data();
	for (unsigned long i = 0; i < nRows; ++i)
		i16[i] = i % 10;
	delete d;

	col = tab->addColumn("int32",Column::Int32,"int32 data","dm");
	d = col->data();
	int32 *i32 = d->int32Data();
	cout << i32 << endl;
	for (unsigned long i = 0; i < nRows; ++i)
		i32[i] = int(5 - 0.1*i);
	delete d;

	col = tab->addColumn("real32",Column::Real32,"real32 data","m");
	d = col->data();
	real32 *r32 = d->real32Data();
	for (unsigned long i = 0; i < nRows; ++i)
		r32[i] = sin(2*M_PI*i/nRows);
	delete d;

	col = tab->addColumn("real64",Column::Real64,"real64 data","Dm");
	d = col->data();
	real64 *r64 = d->real64Data();
	for (unsigned long i = 0; i < nRows; ++i)
		r64[i] = atan(-M_PI+2*M_PI*i/nRows);
	delete d;

	vector<unsigned long> strlen;
	strlen.push_back(10);
	col = tab->addColumn("string",Column::DString,"string data","",strlen);
	d = col->data();
	char *s = d->stringData();
	int len = d->size()[0];
	assert( len == 10 );
	for (unsigned long i = 0; i < nRows; ++i) {
	stringstream ss;
	ss << "string"<<i<<ends;
	strncpy(s + d->position(i), ss.str().c_str(), len);
	}
	delete d;

	unsigned vlen = nRows/2;
	vector<unsigned long> vecLen(1); vecLen[0] = vlen;
	col = tab->addColumn("vecreal32", Column::Real32, "vector real32", "",
						 vecLen);
	d = col->data();
	r32 = d->real32Data();
	for (unsigned row=0; row<nRows; ++row)
		for (unsigned n=0; n<vlen; ++n)
			r32[d->position(row, n)] =
								cos(2.*M_PI/(vlen-1)*n+M_PI/(nRows-1)*row);
	delete d;		

	vlen = nRows+20;
	vecLen[0] = vlen;
	col = tab->addColumn("vecreal64", Column::Real64, "vector real64", "",
						 vecLen);
	d = col->data();
	r64 = d->real64Data();
	for (unsigned row=0; row<nRows; ++row)
		for (unsigned n=0; n<vlen; ++n)
			r64[d->position(row, n)] =
								sin(2.*M_PI/(vlen-1)*n+M_PI/(nRows-1)*row);
	delete d;		

  dataSetServer->close(set);

  return 0;
}

